    function [value,isterminal,direction] = hopper_events(t,y,hopper)
    % Event detector for hopper simulation - includes maximum extension on
    % spring
        mass_height=y(1);
        mass_vel=y(2);
        foot_height=y(3);
        foot_vel=y(4);

        if hopper.state_act == hopper.ON
            Fappl = hopper.F;
        else
            Fappl = 0;
        end

       Fes = Fappl - hopper.m1*hopper.g - hopper.k*hopper.max_ext - hopper.b*(mass_vel-foot_vel);
       Fn = Fappl+hopper.m2*hopper.g-hopper.k*mass_height-hopper.b*mass_vel-Fes;
       switch hopper.state_foot
            case hopper.GROUND  %Terminate when ground reaction = 0 or time to change force
                value = [Fn             % GRF
                         mod(t,hopper.period)-hopper.duty*hopper.period/2 %Turn F ON
                         mod(t,hopper.period)-hopper.duty*hopper.period/2-hopper.duty*hopper.period]';  % Turn F OFF
                isterminal = [1, 1, 1]';
                direction =  [-1; 1; 1]';
            case hopper.AIR     % Terminate when foot hits ground or time to change force
       value = [foot_height     % Foot Contact
                mod(t,hopper.period)-hopper.duty*hopper.period/2  %Turn F ON
                mod(t,hopper.period)-hopper.duty*hopper.period/2-hopper.duty*hopper.period]';  % Turn F OFF
                isterminal = [1, 1, 1]';
                direction = [-1; 1; 1]';
        end  %switch
        switch hopper.state_ext
            case hopper.FREE   % Terminate when y1-y2 = max_ext
                value(hopper.HIT_LIMIT) = mass_height - foot_height - hopper.max_ext;
                isterminal(hopper.HIT_LIMIT) = 1;
                direction(hopper.HIT_LIMIT) = 1;
            case hopper.LIMIT  % Terminate when Fes <= 0
                value(hopper.HIT_LIMIT) = Fes;
                isterminal(hopper.HIT_LIMIT) = 1;
                direction(hopper.HIT_LIMIT) = 1;
        end
    end  %end function, hopper_events.
%-------------------------------------------------------------------
