function hopper_plot(data)
% MODIFIED FOR MAX EXTENSION

state_color = ['r' 'g' 'b' 'k'];
state_marker = ['.' 'o'];

figure(1)
clf; hold on; zoom on;

plot(data.tout,data.yout(:,1)*100,'b');
plot(data.tout,data.yout(:,3)*100,'r');

%plot(tout,yout(:,1),'b.');
%plot(tout,yout(:,3),'r.');

iL = 1;
while iL*data.hopper.period < data.tout(length(data.tout))
   bottom = min(data.yout(:,1))*100;
   top = max(data.yout(:,1))*100;
   left = data.hopper.period*(iL-1)+data.hopper.duty*data.hopper.period/2;
   right = left + data.hopper.duty*data.hopper.period;
   %h = line([data.hopper.period*(iL-1) data.hopper.period*(iL-1)],[min(data.yout(:,1)) max(data.yout(:,1))]);
   %set(h,'Color',[0.8 0.8 0.8]);   
   h = fill([left right right left]',[bottom bottom top top]',[0.8 0.8 0.8]);
   set(h,'LineStyle','none');
   iL = iL + 1;
end

plot(data.tout,data.yout(:,1)*100,'b');
plot(data.tout,data.yout(:,3)*100,'r');
legend('Body height about equilibrium','Foot height above ground',4);
hold off

title(sprintf('Hopper Simulation Results, frequency: %0.2f Hz\nPeriod-%d stable, Height=%0.2f cm, fn=%0.2f Hz, z=%0.2f',...
    data.hopper.frequency,data.periodicity,data.ss_height*100,data.hopper.fn,data.hopper.z),...
    'FontSize',12,'FontWeight','bold');
xlabel('time(s)')
ylabel('vertical displacement (cm)');


figure(2)
Fn = zeros(size(data.tout));
for i=1:size(data.tout,1)
    if data.stout_foot(i)==data.hopper.GROUND
        Fn(i) = data.stout_act(i)*data.hopper.F + ...
            data.hopper.m2*data.hopper.g - data.hopper.k*data.yout(i,1) - ...
            data.hopper.b*data.yout(i,2);
    end
end

plot(data.tout,Fn,'b',data.tout,data.yout(:,3)*20,'r',data.tout,data.stout_foot,'g',data.tout,data.stout_act,'c',data.tout,data.stout_ext,'k',data.tout,(data.yout(:,1)-data.yout(:,3))*100,'m');
title('Ground Reaction Force, Foot Height, Foot State, and Actuator State','FontSize',12,'FontWeight','bold');
xlabel('time(s)');
ylabel('ground reaction force (N)');
legend('grf','foot height','foot state','actuator state','max extension','extension')
grid on


figure(3)
plot(data.tout,data.stout_act,'b');
grid on
xlabel('time(s)');
ylabel('actuator');
title('Force Actuation','FontSize',12,'FontWeight','bold');

% figure(4)
% plot(tout,mod(tout,hopper.period)-hopper.duty*hopper.period/2,'b',...
%     tout,mod(tout,hopper.period)-hopper.duty*hopper.period/2-hopper.duty*hopper.period,'r',...
%     tout,stout_act*hopper.period,'g');
% legend('Force ON','Force OFF','Actual');
% xlabel('time(s)');
% title('Actuation Troubleshooting','FontSize',12,'FontWeight','bold');
% grid on

end
